#ifndef lint
static char SCCSid[] = "@(#) ./blog/b2ibmvt.c 12/01/93";
#endif

#include <stdio.h>
#include "tools.h"
#include "blog/blog.h"
#include "comm/comm.h"
#include "comm/logging.h"

/* 
  This file will contain routines to output ibm-vt format trace files.
  This is waiting on the location of ev.h, documented in the IBM manuals.

  This is a hacked version of the PICL output code.

  NOT YET DONE.
 */
#if defined(rs6000) && defined(euih)
#include "/usr/lpp/vt/libXv/Xv/ev.h"
typedef uint_t u_int;
typedef uchar_t u_char;
#include "/usr/lpp/vt/libXv/Xv/VT_trc.h"

/* Here are routines to buffer the byte-oriented output */
#define BUFSIZ 4096
static int fd;
static char buf[BUFSIZ];
static int  bufpos = 0;  /* NEXT location */

static void BBBWRITE(p,n)
char *p;
int  n;
{ 
int mmm = n, nt; 
while (mmm) {
    nt = mmm;
    if (nt + bufpos >= BUFSIZ) nt = BUFSIZ - bufpos;
    memcpy( buf + bufpos, p, nt );
    bufpos += nt;
    if (bufpos == BUFSIZ) {
	write( fd, buf, BUFSIZ );
	bufpos = 0;
	}
    p += nt;
    mmm -= nt;
    }
}

void BLOG2VTflush()
{
if (bufpos > 0) 
    write( fd, buf, bufpos );
bufpos = 0;
}

static int prev_len = 0;
static void BBBVTHeader( len, proc, subtype, time )
int len, proc;
unsigned long time[2];
{
struct _ev_hdr header;

header.evh_prev_len        = prev_len;
header.evh_len             = sizeof(struct _ev_hdr) + len;
header.evh_type            = evh_type_EUI1;
header.evh_subtype         = subtype;
/* Currently, time is in msec in the low word */
header.evh_time.tv_sec     = ((double)(time[0])) / 1000.0;
header.evh_time.tv_nsec    = 1000 * (time[0] % 1000);
header.evh_proc     = proc;
BBBWRITE(&header, sizeof(struct _ev_hdr) );
prev_len += len + sizeof(struct _ev_hdr);
}

void BLOG2VTHeader( fp, procid )
FILE *fp;
int  procid;
{
struct _ev_hdr header;
VT_tracefile_hdr hdr;

fd = fileno(fp);

header.evh_prev_len = 0;
header.evh_len      = sizeof(struct _ev_hdr) + sizeof(VT_tracefile_hdr);
header.evh_type     = evh_type_EUI1;
header.evh_subtype  = 0;
header.evh_time.tv_sec     = 0;
header.evh_time.tv_nsec     = 0;
header.evh_proc     = 0;
BBBWRITE(&header, sizeof(ev_header) );
hdr.type            = VT_EUI_TRACEFILE;
hdr.trace_rel       = TRACE_RELEASE;
hdr.num_procs       = PInumtids;
strcpy( hdr.pgmname, "Unknown" );
strcpy( hdr.info_string, "Chameleon BLOG output" );
BBBWRITE(&hdr,    sizeof(VT_tracefile_hdr) );
}

void BLOG2VTHeaderFull( fp, procid, nevents, nevent_types, nnodes, 
			  starttime, endtime )
FILE *fp;
int  procid, nevents, nevent_types, nnodes;
unsigned long starttime[2], endtime[2];
{
BLOG2VTHeader( fp, procid );
}

void  BLOG2VTBSENDS( procid, time, dest, tag, len )
int procid, time[2], dest, tag, len;
{
VT_mp_bsend_beg bsend_beg;

BBBVTHeader( sizeof(VT_mp_bsend_beg), procid, 
			 VT_MP_BSEND|BEGIN_REC, time );
bsend_beg.iadr   = 0;
bsend_beg.dest   = dest;
bsend_beg.type   = tag;
bsend_beg.msglen = len;
BBBWRITE( &bsend_beg, sizeof(VT_mp_bsend_beg) );
}
void  BLOG2VTBSENDE( procid, time )
int procid, time[2];
{
VT_mp_bsend_end bsend_end;

BBBVTHeader( sizeof(VT_mp_bsend_end), procid, 
			 VT_MP_BSEND, time );
bsend_end.retcode = 0;
BBBWRITE( &bsend_end, sizeof(VT_mp_bsend_end) );
}

/* 
   This assumes that any a character string may be encoded in the log file.
   We will need to change this to allow the log file to contain additional
   integers, needed for the more elaborate communication tracing
 */
void BLOG2VTOutput( fp, procid, ap )
FILE *fp;
int  procid, *ap;
{
BLOG_HEADER *b;
BLOG_VFIELD *v;
int         lnleft;
int         *ip,      /* pointer to integer data record in event */
            ilen;     /* Size of that event */
ev_header header;
VT_mp_bsend_beg bsend_beg;
VT_mp_bsend_end bsend_end;
VT_mp_brecv_beg brecv_beg;
VT_mp_brecv_end brecv_end;
VT_mp_send_beg  send_beg;
VT_mp_send_end  send_end;
VT_mp_recv_beg  recv_beg;
VT_mp_recv_end  recv_end;

b      = (BLOG_HEADER *)ap;
/* -1 is the "mark" event */
lnleft = b->len;
ap += (sizeof(BLOG_HEADER) / sizeof(int));
lnleft -= (sizeof(BLOG_HEADER) / sizeof(int));
if (lnleft > 0) {
    while (lnleft) {
	/* There may be a string or integer data.  */
	v      = (BLOG_VFIELD *)ap;
	ap     += v->len;
	lnleft -= v->len;
	if (v->dtype == BLOG_INT) {
	    ip = v->other;
	    ilen = v->len;
	    }
	}
    
    switch (b->event) {
	case LOG_BSENDS:
	    BBBVTHeader( sizeof(VT_mp_bsend_beg), procid, 
			 VT_MP_BSEND|BEGIN_REC, b->time.s1 );
	    bsend_beg.iadr   = 0;
	    bsend_beg.dest   = ip[2];
	    bsend_beg.type   = ip[1];
	    bsend_beg.msglen = ip[0];
	    BBBWRITE( sizeof(VT_mp_bsend_beg), &bsend_beg );
	    break;
	case LOG_BSENDE:
	    BBBVTHeader( sizeof(VT_mp_bsend_end), procid, 
			 VT_MP_BSEND, b->time.s1 );
	    bsend_end.retcode= 0;
	    BBBWRITE( sizeof(VT_mp_bsend_end), &bsend_end );
	    break;
	case LOG_BRECVS:
	    fprintf( fp, "7 %u %u %d\n",
		     b->time.s1[0], b->time.s1[1], procid );
	    break;
	case LOG_BRECVE:
	    fprintf( fp, "8 %u %u %d %d %d %d\n",
		     b->time.s1[0], b->time.s1[1], procid, 
		     ip[2], ip[1], ip[0] );
	    break;
	case LOG_IRECVS:
	    /* 
	    fprintf( fp, "4 %u %u %d %d %d %d\n",
		     b->time.s1[0], b->time.s1[1], procid, 
		     ip[2], ip[1], ip[0] );
		      */
	    break;
	case LOG_IRECVE:
	    /* 
	    fprintf( fp, "4 %u %u %d %d %d %d\n",
		     b->time.s1[0], b->time.s1[1], procid, 
		     ip[2], ip[1], ip[0] );
		      */
	    break;
	/* User defined events and other events are ignored */
        default:
	    break;
	}
    }
/* else
    fprintf( fp, "0\n" ); */
}

#endif
