/* @(#) ./dgraph/dgraph.h 12/01/93 */

#ifndef _GRINCLUDE
#define _GRINCLUDE
/* Operations */
/* We provide for now a simple linear scaling system.   */
typedef enum { GRBLACK, GRWHITE, GRRED, GRBLUE, GRGREEN, GRYELLOW } GRColor;
typedef enum { GRSOLID, GRDASH, GRDOTS } GRLineStyle;
typedef enum { GRCENTER, GRLEFT, GRRIGHT } GRJustification;

typedef struct {
    void (*DrawLine)(),
         (*AddLine)(),
         (*DrawLines)(),
         (*StartPage)(),
         (*EndPage)(),
         (*DrawRectangle)(),
         (*DrawText)(),
         (*DrawAxis)(),
         (*DrawHistogram)(),
         (*SetLimits)(),
         (*Close)();
    double xmin, xmax, ymin, ymax;
    int    use_color;
    int    has_axis;
    int    is_interactive;
    void   *Dev;                   /* Device specific information */
    } GRctx;

/* Style allows both black and white and color to coexist by selecting
   simultaneously the b&w and color styles to use */
typedef struct {
    /* Common styles (must be available in both b&w and color) */
    double width;
    int    line_style;
    int    fill_style;
    int    color;
    /* line style for b&w only */
    int    bw_line_style;
    } GRStyle;
/* We need some macros to manipulate the style */

#define GRDrawAxis( gctx, flag ) (*(gctx)->DrawAxis)( gctx,flag )
#define GRSetLimits( gctx, xmin, xmax, ymin, ymax ) \
    (*(gctx)->SetLimits)( gctx, xmin, xmax, ymin, ymax ) 
#define GRClose(gctx) (*(gctx)->Close)(gctx)
#define GRDrawLine( gctx, x1, y1, x2, y2, style ) \
    (*(gctx)->DrawLine)( gctx, x1, y1, x2, y2, style ) 
#define GRAddLine( gctx, x1, y1 ) (*(gctx)->AddLine)( gctx, x1, y1 )
#define GRDrawLines( gctx, n, x, y, style ) \
    (*(gctx)->DrawLines)( gctx, n, x, y, style )
#define GRStartPage( gctx ) (*(gctx)->StartPage)( gctx )
#define GREndPage( gctx )   (*(gctx)->EndPage)( gctx )
#define GRDrawRectangle( gctx, x1, x2, y1, y2, style ) \
    (*(gctx)->DrawRectangle)( gctx, x1, x2, y1, y2, style )
#define GRDrawText( gctx, x, y, str, size, just ) \
    (*(gctx)->DrawText)( gctx, x, y, str, size, just )
#define GRDrawHistogram( gctx, x, nx, binsize ) \
    (*(gctx)->DrawHistogram)( gctx, x, nx, binsize )
#define GRIsInteractive( gctx ) (gctx)->is_interactive

extern GRctx *GRCitCreate(), *GRXCreate(), *GRCreateFromArgs(), 
             *GRCreateFromArgsNoX();

#endif
